use std::fmt::Write;

use crate::data::{BoatsLayout, MapCellContent};

#[derive(Debug, Clone, serde::Serialize, serde::Deserialize)]
pub struct EndGameMap {
    pub boats: BoatsLayout,
    pub grid: Vec<Vec<MapCellContent>>,
}

impl EndGameMap {
    pub fn get_map(&self) -> String {
        let mut s = String::new();
        for row in &self.grid {
            for col in row {
                write!(&mut s, "{} ", col.letter()).unwrap();
            }
            s.push('\n');
        }
        s
    }
}
